diff -Nur gnome-power-manager-2.24.4-org/src/gpm-dpms.c gnome-power-manager-2.24.4/src/gpm-dpms.c
--- gnome-power-manager-2.24.4-org/src/gpm-dpms.c	2009-12-31 13:54:06.292238283 +0800
+++ gnome-power-manager-2.24.4/src/gpm-dpms.c	2009-12-31 14:02:05.680140581 +0800
@@ -39,7 +39,6 @@
 #ifdef HAVE_DPMS_EXTENSION
 #include <X11/Xproto.h>
 #include <X11/extensions/dpms.h>
-#include <X11/extensions/dpmsstr.h>
 #endif
 
 #include "gpm-conf.h"
diff -Nur gnome-power-manager-2.24.4-org/configure.ac gnome-power-manager-2.24.4/configure.ac
--- gnome-power-manager-2.24.4-org/configure.ac	2009-12-31 13:54:06.292238283 +0800
+++ gnome-power-manager-2.24.4/configure.ac	2009-12-31 14:02:05.680140581 +0800
@@ -27,12 +27,6 @@ if test "$GCC" = "yes"; then
 fi
 
 dnl ---------------------------------------------------------------------------
-dnl - Debugging switches (uncomment this if you want to use gdb)
-dnl ---------------------------------------------------------------------------
-CPPFLAGS="$CPPFLAGS -g"
-CPPFLAGS="$CPPFLAGS -fexceptions"
-
-dnl ---------------------------------------------------------------------------
 dnl - GProf switches (do not use for normal building)
 dnl ---------------------------------------------------------------------------
 #CPPFLAGS="$CPPFLAGS -c -pg"
diff -Nur gnome-power-manager-2.21.1-org/src/gpm-array-float.c gnome-power-manager-2.21.1/src/gpm-array-float.c
--- gnome-power-manager-2.21.1-org/src/gpm-array-float.c	2007-12-17 17:12:56.275650000 +0800
+++ gnome-power-manager-2.21.1/src/gpm-array-float.c	2007-12-17 17:02:07.642824000 +0800
@@ -75,7 +75,7 @@
  *
  * @array: input array
  **/
-inline gfloat
+gfloat
 gpm_array_float_get (GArray *array, guint i)
 {
 	if (i >= array->len) {
@@ -89,7 +89,7 @@
  *
  * @array: input array
  **/
-inline void
+void
 gpm_array_float_set (GArray *array, guint i, gfloat value)
 {
 	g_array_index (array, gfloat, i) = value;
diff -Nur gnome-power-manager-2.21.1-org/src/gpm-array-float.h gnome-power-manager-2.21.1/src/gpm-array-float.h
--- gnome-power-manager-2.21.1-org/src/gpm-array-float.h	2007-12-17 17:12:56.277090000 +0800
+++ gnome-power-manager-2.21.1/src/gpm-array-float.h	2007-12-17 17:02:07.643637000 +0800
@@ -49,9 +49,9 @@
 gboolean	 gpm_array_float_print			(GArray		*array);
 GArray		*gpm_array_float_convolve		(GArray		*data,
 							 GArray		*kernel);
-inline gfloat	 gpm_array_float_get			(GArray		*array,
+gfloat		 gpm_array_float_get			(GArray		*array,
 							 guint		 i);
-inline void	 gpm_array_float_set			(GArray		*array,
+void		 gpm_array_float_set			(GArray		*array,
 							 guint		 i,
 							 gfloat		 value);
 
--- gnome-power-manager-2.23.91/configure.ac.orig	2008-09-02 10:39:13.239161437 +0800
+++ gnome-power-manager-2.23.91/configure.ac	2008-09-02 10:39:31.005118555 +0800
@@ -246,7 +246,7 @@
 AC_ARG_ENABLE(gconf-defaults,
               AS_HELP_STRING([--disable-gconf-defaults],
                              [Allow setting gconf default settings]),
-              enable_gconfdefaults=$enableval,enable_gconfdefaults=yes)
+              enable_gconfdefaults=$enableval,enable_gconfdefaults=no)
 
 AC_MSG_CHECKING([whether to support gconf defaults])
 have_gconfdefaults=no
--- gnome-power-manager-2.24.0/src/egg-debug.h.orig	2008-09-23 10:39:26.172843000 +0800
+++ gnome-power-manager-2.24.0/src/egg-debug.h	2008-09-23 10:39:58.561354000 +0800
@@ -27,7 +27,7 @@
 
 G_BEGIN_DECLS
 
-#if defined(__STDC_VERSION__) && __STDC_VERSION__ >= 199901L
+#if defined(__STDC_VERSION__) && __STDC_VERSION__ >= 199409L
 /**
  * egg_debug:
  *
@@ -66,15 +66,15 @@
 void		egg_debug_real			(const gchar	*func,
 						 const gchar	*file,
 						 int		 line,
-						 const gchar	*format, ...) __attribute__((format (printf,4,5)));
+						 const gchar	*format, ...);
 void		egg_warning_real		(const gchar	*func,
 						 const gchar	*file,
 						 int		 line,
-						 const gchar	*format, ...) __attribute__((format (printf,4,5)));
+						 const gchar	*format, ...);
 void		egg_error_real			(const gchar	*func,
 						 const gchar	*file,
 						 int		 line,
-						 const gchar	*format, ...) __attribute__((format (printf,4,5)));
+						 const gchar	*format, ...);
 
 G_END_DECLS
 